
#include <ESP8266WiFi.h>

#define RX_BUFSIZE 1024

const char* ssid_ap = "TCP_Test";
const char* password_ap = "frodo123";

IPAddress local_IP(10,10,10,1);
IPAddress gateway(10,10,10,1);
IPAddress subnet(255,255,255,0);

WiFiServer TcpServer(23);
WiFiClient TcpClient;

uint8_t _RxBuf[ RX_BUFSIZE ];
int cnt = 0;
int t0=0 ;

void setup(void)
{
  Serial.begin(115200);
  Serial.print("\n");
  Serial.println( "MaxReader" );

  Serial.printf("\nStarting Access Point \"%s\"\n", ssid_ap);
  WiFi.persistent(false);
  WiFi.softAPConfig( local_IP, gateway, subnet );
  WiFi.softAP( ssid_ap,password_ap );
  Serial.print("IP address = ");
  Serial.println(WiFi.softAPIP());  

  TcpServer.begin();
  TcpServer.setNoDelay(true);
  Serial.println("tcp server running" );
}
 
void loop(void)
{
  // Ist Element bereits benutzt ?
  if( TcpClient )
  {
    if( !TcpClient.connected() )
    {
      Serial.println("Client disconnected remotely ... "); 
      TcpClient.stop();
    }
  }

  // Hat sich ein neuer Client angemeldet ?
  if( TcpServer.hasClient())
  {
    TcpClient.stop();
    Serial.println("New Client connected");
    TcpClient = TcpServer.available(); 
  }
        
  if( TcpClient && TcpClient.connected())
  {
    if( TcpClient.available())
      cnt += TcpClient.read( _RxBuf, RX_BUFSIZE );
  }
  
  if(( millis() - t0 ) > 1000 )
  {
    t0 = millis();
    Serial.printf( "RX-Rate: %d Bytes/s\n", cnt );
    cnt = 0;
  }
}
