
#include "ESP8266WiFi.h"
 
const char* ssid        = "TCP_Test";
const char* password    = "frodo123";
const char* remote_host = "10.10.10.1";
const uint16_t port = 23;
int _WiFiconnected = true;
int n=0, m=0, p=0, t0, t1, cnt=0;
char buf[1024];
 
WiFiClient client;

void setup()
{
  Serial.begin(115200);
  Serial.printf("\nStart\n");

  WiFi.begin(ssid, password);
}

void loop()
{
  if( WiFi.status() != WL_CONNECTED )
  {
    // WIFI DISCONNECTED 
    
    if( _WiFiconnected == true )
    {
      _WiFiconnected = false ;
      Serial.printf( "%s disconnected\n", ssid ); 
      Serial.printf( "Connecting with %s ", ssid);

//      client.stop();
    }
    delay(1000);
    Serial.printf(".");
  }
  else
  {
    // WIFI CONNECTED 
    
    if( _WiFiconnected == false )
    {
      _WiFiconnected = true ;
      Serial.printf("\r\nConnected, myip is ");
      Serial.println(WiFi.localIP());
    }

    if( client.connected())
    {
      // Es werden 1000 x 200 Zeichen pro Sekunde gesendet 
      if(( millis() - t0 ) >= 1 )
      {
        t0 = millis();

        // Nur weiter senden, wenn Platz im Sendepuffer (sonst evt. Crash bei Verbindungsverlust)
        if( client.availableForWrite() > 200 )
        {
          char buf[256];
          n = sprintf( buf, "%198d\r\n", p++ );  // String mit 200 Zeichen Länge, Zahl am Ende
          m = client.write( buf, n);

          if( m != n )
            Serial.printf("ERROR: transmission failed\n");
          else  
          {
            cnt += m;
            client.flush();
          }
        }
      }

      if(( millis() - t1 ) > 1000 )
      {
        t1 = millis();
        Serial.printf( "TX-Rate: %d Bytes/s\n", cnt );
        cnt = 0;
      }
    }
    else
    {
      if ( client.connect( remote_host, port)) 
        Serial.printf("Connected to %s (%d)\n", remote_host, port );
      else
        Serial.printf("Connection to \"%s\" failed, retry\n", ssid );
    }
  }
}
